//
// simple implementations of two algorithms for computing GCD
// - Euclid's algorithm
// - linear search
//

public class Gcd
{
    public static void main( String[] args )
    {
        int m = Integer.parseInt( args[0] );
        int n = Integer.parseInt( args[1] );

        System.out.println( "Euclid: " + euclid(m, n) );
        System.out.println( "Linear: " + linear(m, n) );
    }

    public static int euclid( int m, int n )
    {
        while ( n != 0 )
        {
            int r = m % n;
            m = n;
            n = r;
        }
        return m;
    }

    public static int linear( int m, int n )
    {
        int t = Math.min( m, n );
        while ( t > 0 )
        {
            if ( ( m % t == 0 ) && ( n % t == 0 ) )
                return t;
            t--;
        }
        return -1;    // error, but Java likes a return here
    }
}
